Package com.sas.metadata.remote

# Interface RowSelector

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `QueryClause`, `Remote`, `Root`, `SecondaryType`

public interface RowSelector extends QueryClause
Used to document a SAS DATA step SELECT statement.

Attributes of RowSelector are:

- `RowsSelected`

Associations of RowSelector are:

- `OwningClassifierMap`

## Usage

To create an instance of this RowSelector, use the `factory` create methods.
Example: create a RowSelector with name "RowSelector_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     RowSelector myObject = (RowSelector) factory.createComplexMetadataObject(objectStore, "RowSelector_Object", MetadataObjects.ROWSELECTOR, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_OWNINGCLASSIFIERMAP_NAME`
  Constant used for the name of the OwningClassifierMap association.
  `static final String`
  `ATTRIBUTE_ROWSSELECTED_NAME`
  Constant used for the name of the RowsSelected attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.QueryClause

  `ASSOCIATION_COLUMNS_NAME, ASSOCIATION_SOURCECODE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ClassifierMap`
  `getOwningClassifierMap()`
  Gets the `ClassifierMap` for `OwningClassifierMap`
  `AssociationList`
  `getOwningClassifierMaps()`
  Gets the Association list of `OwningClassifierMaps`
  `AssociationList`
  `getOwningClassifierMaps(boolean fGoToServer)`
  Gets the Associationlist of `OwningClassifierMaps`
  `String`
  `getRowsSelected()`
  Gets the `String` value of `RowsSelected`
  `int`
  `getRowsSelectedMaxLength()`
  Gets the maximum length of `RowsSelected`
  `int`
  `getRowsSelectedState()`
  Gets the Metadata State of `RowsSelected`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningClassifierMap`
  `void`
  `setOwningClassifierMap(ClassifierMap inObject)`
  Sets the `OwningClassifierMaps` list 0th element to be `inObject`.
  `void`
  `setOwningClassifierMaps(AssociationList list)`
  Sets the `OwningClassifierMaps` list to be `list`.
  `void`
  `setOwningClassifierMaps(AssociationList list, int state)`
  Sets the `OwningClassifierMaps` list to be `list`.
  `void`
  `setRowsSelected(String inRowsSelected)`
  Sets the `RowsSelected` value and sets the state to MetadataState.LOCAL.
  `void`
  `setRowsSelected(String inRowsSelected, int state)`
  Sets the `RowsSelected` Metadata State.
  `void`
  `setRowsSelectedState(int state)`
  Sets the Metadata State of `RowsSelected`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.QueryClause

  `getColumns, getColumns, getSourceCode, getSourceCodes, getSourceCodes, setColumns, setColumns, setSourceCode, setSourceCodes, setSourceCodes`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_ROWSSELECTED_NAME

    static final String ATTRIBUTE_ROWSSELECTED_NAME
    Constant used for the name of the RowsSelected attribute.

    RowsSelected: enumeration: AllRows, Conditions, UserDefinedStatements

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGCLASSIFIERMAP_NAME

    static final String ASSOCIATION_OWNINGCLASSIFIERMAP_NAME
    Constant used for the name of the OwningClassifierMap association.

    OwningClassifierMap: The classifier map that uses this row selector.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningClassifierMap`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `QueryClause`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `QueryClause`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getRowsSelected

    String getRowsSelected() throws RemoteException
    Gets the `String` value of `RowsSelected`
    Returns:
      The `RowsSelected`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getRowsSelectedState

    int getRowsSelectedState() throws RemoteException
    Gets the Metadata State of `RowsSelected`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getRowsSelectedMaxLength

    int getRowsSelectedMaxLength() throws RemoteException
    Gets the maximum length of `RowsSelected`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getOwningClassifierMaps

    AssociationList getOwningClassifierMaps() throws RemoteException, MdException
    Gets the Association list of `OwningClassifierMaps`
    Returns:
      The AssociationList of `OwningClassifierMaps` which can be of type:
      ClassifierMap
      Select
      Join
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningClassifierMap

    ClassifierMap getOwningClassifierMap() throws RemoteException, MdException
    Gets the `ClassifierMap` for `OwningClassifierMap`
    Returns:
      The `ClassifierMap` ( `null` if not set ) of `OwningClassifierMap` which can be of type:
      ClassifierMap
      Select
      Join
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningClassifierMaps

    AssociationList getOwningClassifierMaps(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningClassifierMaps`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `OwningClassifierMaps` which can be of type:
      ClassifierMap
      Select
      Join
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setRowsSelected

    void setRowsSelected(String inRowsSelected) throws RemoteException
    Sets the `RowsSelected` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inRowsSelected` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setRowsSelected

    void setRowsSelected(String inRowsSelected, int state) throws RemoteException
    Sets the `RowsSelected` Metadata State.
    Parameters:
      `inRowsSelected` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setRowsSelectedState

    void setRowsSelectedState(int state) throws RemoteException
    Sets the Metadata State of `RowsSelected`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningClassifierMaps

    void setOwningClassifierMaps(AssociationList list) throws RemoteException
    Sets the `OwningClassifierMaps` list to be `list`. Objects of which can be of type:
    ClassifierMap
    Select
    Join
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningClassifierMaps

    void setOwningClassifierMaps(AssociationList list, int state) throws RemoteException
    Sets the `OwningClassifierMaps` list to be `list`. Objects of which can be of type:
    ClassifierMap
    Select
    Join
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningClassifierMap

    void setOwningClassifierMap(ClassifierMap inObject) throws RemoteException
    Sets the `OwningClassifierMaps` list 0th element to be `inObject`.
    Parameters:
      `inObject` - ClassifierMap
    Throws:
      `RemoteException` - If error communicating with remote object.